<script setup lang="ts">
import { is, useQuasar, type QTableProps } from "quasar";
import { ref, onMounted } from "vue";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";
import { useDataStore } from "@/stores/data";

import type { OtherFormType } from "@/modules/10_registry/interface/index/Main";

import DialogHistory from "@/modules/10_registry/Dialog/DialogHistory.vue";

const $q = useQuasar();
const dataPerson = useDataStore();
const { messageError, date2Thai, onSearchDataTable } = useCounterMixin();

const link = ref<string>("");
const isLoading = ref<boolean>(false);
const isLoadingHistory = ref<boolean>(false);
const idByRow = ref<string>("");
const rows = ref<OtherFormType[]>([]);
const rowsData = ref<OtherFormType[]>([]);
const filter = ref<string>("");
const rowsHistory = ref<OtherFormType[]>([]);
const rowsHistoryData = ref<OtherFormType[]>([]);
const mode = ref<boolean>($q.screen.gt.xs);
const modalHistory = ref<boolean>(false);
const visibleColumns = ref<string[]>([
  "date",
  "detail",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "date",
    align: "left",
    label: "วันที่",
    sortable: true,
    field: "date",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px; width: 50px;",
    format: (v) => date2Thai(v),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const pagination = ref({
  sortBy: "lastUpdatedAt",
});
const visibleColumnsHistory = ref<string[]>([
  "date",
  "detail",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const columnsHistory = ref<QTableProps["columns"]>([
  {
    name: "date",
    align: "left",
    label: "วันที่",
    sortable: true,
    field: "date",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px; width: 50px;",
    format: (v) => date2Thai(v),
  },
  {
    name: "detail",
    align: "left",
    label: "รายละเอียด",
    sortable: true,
    field: "detail",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    format: (v) => date2Thai(v, false, true),
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);

/** ฟังก์ชันดึงข้อมูล */
async function getData() {
  isLoading.value = true;
  await http
    .get(config.API.dataUserOtherByType(link.value))
    .then((res) => {
      const data = res.data.result;
      rows.value = data;
      rowsData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      isLoading.value = false;
    });
}

/**
 * ฟังก์ชันเปิดโมดัลดูประวัติ
 * @param id ID ของแถวที่ต้องการดูประวัติ
 */
function onHistory(id: string) {
  modalHistory.value = true;
  idByRow.value = id;
}

/** ฟังก์ชันดึงประวัติการแก้ไขข้อมูลอื่นๆ */
async function getHistory() {
  isLoadingHistory.value = true;
  rowsHistory.value = [];
  rowsHistoryData.value = [];
  await http
    .get(config.API.dataUserOtherHistoryByType(link.value, idByRow.value))
    .then((res) => {
      const data = res.data.result;
      rowsHistory.value = data;
      rowsHistoryData.value = data;
    })
    .catch((e) => {
      messageError($q, e);
    })
    .finally(() => {
      isLoadingHistory.value = false;
    });
}

/** ฟังก์ชันค้นหาข้อมูลในตาราง */
function onSearch() {
  rows.value = onSearchDataTable(
    filter.value,
    rowsData.value,
    columns.value ? columns.value : []
  );
}

onMounted(async () => {
  link.value = await dataPerson.getProFileType();
  await getData();
});
</script>
<template>
  <div class="col-12">
    <q-toolbar class="q-px-none">
      <span class="text-blue-6 text-weight-bold text-body1">ข้อมูลอื่นๆ</span>
      <q-space />
      <q-input
        v-if="mode"
        class="inputgreen"
        outlined
        dense
        v-model="filter"
        label="ค้นหา"
        style="max-width: 200px"
        @keydown.enter.prevent="onSearch"
      >
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-select
        v-if="mode"
        class="q-ml-sm"
        dense
        multiple
        outlined
        emit-value
        map-options
        options-dense
        option-value="name"
        style="min-width: 140px"
        v-model="visibleColumns"
        :options="columns"
        :display-value="$q.lang.table.columns"
      />
    </q-toolbar>

    <d-table
      flat
      dense
      bordered
      virtual-scroll
      :rows="rows"
      :columns="columns"
      :grid="!mode"
      :rows-per-page-options="[10, 25, 50, 100]"
      :visible-columns="visibleColumns"
      :virtual-scroll-sticky-size-start="48"
      :pagination="pagination"
      :loading="isLoading"
      row-key="id"
    >
      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            <span class="text-weight-medium">{{ col.label }}</span>
          </q-th>
          <q-th auto-width />
        </q-tr>
      </template>

      <template v-if="mode" v-slot:body="props">
        <q-tr :props="props" class="cursor-pointer">
          <q-td v-for="(col, index) in props.cols" :key="col.name">
            {{ col.value ? col.value : "-" }}
          </q-td>
          <q-td auto-width>
            <q-btn
              color="info"
              flat
              dense
              round
              size="14px"
              icon="mdi-history"
              @click="onHistory(props.row.id)"
            >
              <q-tooltip>ประวัติแก้ไขข้อมูลอื่นๆ</q-tooltip>
            </q-btn>
          </q-td>
        </q-tr>
      </template>

      <template v-else v-slot:item="props">
        <div class="q-mb-xs col-xs-12 col-sm-6 col-md-4 col-lg-3">
          <q-card bordered flat>
            <q-list dense class="q-mt-lg relative-position">
              <q-btn
                icon="mdi-history"
                color="info"
                flat
                dense
                round
                size="14px"
                class="absolute_button"
                @click="onHistory(props.row.id)"
              >
                <q-tooltip>ประวัติแก้ไขข้อมูลอื่นๆ</q-tooltip>
              </q-btn>
              <q-item v-for="col in props.cols" :key="col.name">
                <q-item-section class="fix_top">
                  <q-item-label class="text-grey-6 text-weight-medium">{{
                    col.label
                  }}</q-item-label>
                </q-item-section>
                <q-item-section class="fix_top">
                  <q-item-label class="text-dark text-weight-medium">{{
                    col.value ? col.value : "-"
                  }}</q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </template>
    </d-table>
  </div>

  <DialogHistory
    v-model:modal="modalHistory"
    :title="'ประวัติแก้ไขข้อมูลอื่นๆ'"
    :getData="getHistory"
    :rows="rowsHistory"
    :rows-data="rowsHistoryData"
    :visibleColumns="visibleColumnsHistory"
    :columns="columnsHistory"
    :is-loading="isLoadingHistory"
  />
</template>
<style scoped>
.absolute_button {
  position: absolute;
  right: 5px;
  top: -20px;
}

.fix_top {
  justify-content: start !important;
}
</style>
